<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html" xmlns:f="http://java.sun.com/jsf/core"
  xmlns:ship="http://xmlns.jcp.org/jsf/composite/ship" xmlns:p="http://primefaces.org/ui">
<h:head></h:head>
<h:body>
  <ui:composition template="/pages/primodaltemplate.xhtml">
    <ui:define name="title">
      <h:outputText value="#{facesContext.translate('title.item.edit', studyModel.element.name)}" />
    </ui:define>
    <ui:define name="body">
      <h:panelGrid columns="2" style="margin-bottom: 12px; margin-top: 4px;">
        <h:outputText value="#{facesContext.translate('tooltip.vargroup.element')}" style="margin-bottom: 12px" />
        <ui:repeat value="#{studyModel.parents}" var="b">
          <h:outputText value="#{b.name}" styleClass="breadcrumbpri" />
        </ui:repeat>
      </h:panelGrid>

      <!-- for departments -->
      <ui:fragment rendered="#{!studyModel.element.isVariable}">
        <ship:card id="card1" title="#{facesContext.translate('label.study.usage.browser')}">
          <p:panelGrid columns="2" columnClasses="width200px" style="width: 100%">
            <h:outputText value="#{facesContext.translate('label.techname')}" />
            <p:inputText id="name_dept" value="#{studyModel.element.name}" style="width: 99%" required="true" requiredMessage="#{facesContext.translate('error.mustnotbeempty', 'label.name')}" />
            <h:outputText value="#{facesContext.translate('label.guiname')}" />
            <ship:inputJson id="descr_dept" value="#{studyModel.element.translationJson}" type="translation" typerestriction="#{studyModel.element.localesJson}" width="99%" labelall="#{facesContext.translate('label.display.all.translations')}" />
          </p:panelGrid>
        </ship:card>
        <ship:card id="card2" title="#{facesContext.translate('label.study.usage.report')}">
          <p:panelGrid columns="2" columnClasses="width200px" style="width: 100%">
            <h:outputText value="#{facesContext.translate('label.uniquename')}" />
            <h:outputText value="#{studyModel.element.uniqueName}" />
            <h:outputText value="#{facesContext.translate('label.study.variable.missinglist')}" />
            <p:selectOneMenu value="#{studyModel.element.fkMissinglist}" style="width: 95%">
              <f:selectItem itemValue="" itemLabel="#{facesContext.translate('label.missinglist.inherit')}" />
              <f:selectItems value="#{studyModel.missinglists}" var="ml" itemValue="#{ml.id}" itemLabel="#{ml.name} (#{ml.summary})" />
            </p:selectOneMenu>
          </p:panelGrid>
        </ship:card>
      </ui:fragment>

      <!-- for variables -->
      <ui:fragment rendered="#{studyModel.element.isVariable}">
        <ship:card id="card3" title="#{facesContext.translate('label.study.usage.browser')}">
          <p:panelGrid columns="2" columnClasses="width200px" style="width: 100%">
            <!-- not optional due to historical reasons -->
            <h:outputText value="#{facesContext.translate('label.techname')}" />
            <p:inputText id="name" value="#{studyModel.variable.name}" style="width: 99%" required="true" requiredMessage="#{facesContext.translate('error.mustnotbeempty', 'label.name')}" />
            <h:outputText value="#{facesContext.translate('label.guiname')}" />
            <ship:inputJson id="descr" value="#{studyModel.variable.translationJson}" type="translation" typerestriction="#{studyModel.variable.localesJson}" width="99%" labelall="#{facesContext.translate('label.display.all.translations')}" />
          </p:panelGrid>
        </ship:card>
        <ship:card id="card4" title="#{facesContext.translate('label.study.usage.report')}">
          <p:panelGrid columns="2" columnClasses="width200px" style="width: 100%">
            <h:outputText value="#{facesContext.translate('label.columnname')}" />
            <p:inputText id="colname" value="#{studyModel.variable.columnName}" style="width: 99%" required="true"
              requiredMessage="#{facesContext.translate('error.mustnotbeempty', 'label.columnname')}" />
            <h:outputText value="#{facesContext.translate('label.uniquename')}" />
            <h:outputText value="#{studyModel.element.uniqueName}" />
            <h:outputText value="#{facesContext.translate('label.variable.datatype')}" />
            <p:selectOneMenu id="scale" value="#{studyModel.variable.datatype}" filter="true" style="width: 95%">
              <f:selectItem itemValue="" itemLabel="#{facesContext.translate('button.choose')}" />
              <f:selectItem itemValue="string" itemLabel="string" />
              <f:selectItem itemValue="integer" itemLabel="integer" />
              <f:selectItem itemValue="float" itemLabel="float" />
              <f:selectItem itemValue="datetime" itemLabel="datetime" />
            </p:selectOneMenu>
            <h:outputText value="#{facesContext.translate('label.study.variable.valuelist')}" title="#{facesContext.translate('tooltip.study.valuelist')}" />
            <p:inputText id="valuelistinput" value="#{studyModel.variable.valuelist}" style="width: 99%" />
            <h:outputText value="#{facesContext.translate('label.study.variable.idvariable')}" />
            <p:inputSwitch id="idvar" value="#{studyModel.variable.idvariable}" />
            <h:outputText value="#{facesContext.translate('label.study.variable.variableusage')}" />
            <p:selectOneMenu id="usage" value="#{studyModel.variable.fkVariableusage}" filter="true" style="width: 95%">
              <f:selectItems value="#{studyModel.variableusages}" var="u" itemValue="#{u.pk}" itemLabel="#{facesContext.translateKey(u.fkLang)}" />
            </p:selectOneMenu>
            <h:outputText value="#{facesContext.translate('label.study.variable.missinglist')}" />
            <p:selectOneMenu value="#{studyModel.variable.fkMissinglist}" style="width: 95%">
              <f:selectItem itemValue="" itemLabel="#{facesContext.translate('label.missinglist.inherit')}" />
              <f:selectItems value="#{studyModel.missinglists}" var="ml" itemValue="#{ml.id}" itemLabel="#{ml.name} (#{ml.summary})" />
            </p:selectOneMenu>
          </p:panelGrid>
          <div class="cardsubhead">
            <h:outputText value="#{facesContext.translate('label.study.edit.headline.variableattributes')}" />
          </div>
          <p:dataTable id="attributes" widgetVar="attributes" value="#{studyModel.variable.attributes}" var="a">
            <p:column headerText="#{facesContext.translate('label.study.variable.attribute.role')}">
              <p:selectOneMenu id="rolename" value="#{a.roleJson}">
                <!-- converter="VariableAttributeRoleConverter"> doesn't work -->
                <p:ajax update="form:card4:attributes" />
                <f:selectItems value="#{studyModel.variableattributeroles}" var="r" itemValue="#{r.toJson()}" itemLabel="#{r.name}" />
              </p:selectOneMenu>
            </p:column>
            <p:column headerText="#{facesContext.translate('label.name')}">
              <!-- TODO: replace by p:autoComplete -->
              <p:inputText id="name" value="#{a.name}" typeahead="true" typeaheadValues="#{studyController.variableattributeNames}" />
            </p:column>
            <p:column headerText="#{facesContext.translate('label.study.variable.attribute.value')}">
              <h:outputText value="#{a.value}" rendered="#{a.hasInputWidget}" />
              <p:staticMessage severity="danger" rendered="#{a.hasInputWidget}" detail="#{a.role.inputWidget} not yet developed" />
              <!-- TODO: add new input widgets here -->
              <p:inputText id="inputtext" value="#{a.value}" rendered="#{!a.hasInputWidget}">
                <f:validateRegex pattern="#{a.role.regexpattern}" disabled="#{!a.hasRegexpattern}" />
              </p:inputText>
            </p:column>
            <p:column headerText="#{facesContext.translate('label.study.variable.attribute.isprimaryattribute')}">
              <p:inputSwitch id="prima" value="#{a.isPrimaryAttribute}" rendered="#{a.role.hasPrimaryAttribute}" />
            </p:column>
            <p:column headerText="#{facesContext.translate('label.study.variable.attribute.locale')}">
              <p:selectOneMenu id="locale" value="#{a.locale}" rendered="#{a.role.hasLocale}">
                <f:selectItems value="#{lang.countries}" var="i" itemValue="#{i}" itemLabel="#{facesContext.displayLanguage(i, lang.locale)}" />
              </p:selectOneMenu>
            </p:column>
            <p:column headerText="#{facesContext.translate('label.actions')}">
              <ship:removeButton id="btn_deleteAttribute" action="#{studyController.doRemoveAttribute(studyModel.variable, a)}" tooltip="#{facesContext.translate('button.delete')}" immediate="true"
                approveButtonLabel="#{facesContext.translate('button.yes')}" cancelButtonLabel="#{facesContext.translate('button.no')}"
                title="#{facesContext.translate('title.delete.approve')}">
                <h:outputText value="#{facesContext.translate('confirmation.delete', a.name)}" />
              </ship:removeButton>
            </p:column>
          </p:dataTable>
          <p:commandButton id="btn_addAttribute" action="#{studyController.doAddAttribute(studyModel.variable)}" value="#{facesContext.translate('button.add')}" ajax="true" update="@widgetVar(attributes)" />
        </ship:card>
      </ui:fragment>
    </ui:define>
    <ui:define name="formbuttons">
      <p:commandButton id="btn_updatedpt" action="#{studyController.doUpdateDepartment}" value="#{facesContext.translate('button.approve')}" rendered="#{!studyModel.element.isVariable}"
        ajax="false" />
      <p:commandButton id="btn_updatevar" action="#{studyController.doUpdateVariable}" value="#{facesContext.translate('button.approve')}" ajax="false"
        rendered="#{studyModel.element.isVariable}" />
      <p:commandButton id="btn_canceldept" action="#{studyController.toWelcome(studyModel.element.parent)}" value="#{facesContext.translate('button.cancel')}" immediate="true" ajax="false"
        rendered="#{!studyModel.element.isVariable}" />
      <p:commandButton id="btn_cancelvar" action="#{studyController.toWelcome(studyModel.variable.keyParentElement)}" value="#{facesContext.translate('button.cancel')}" immediate="true"
        ajax="false" rendered="#{studyModel.element.isVariable}" />
      <p:commandButton id="btn_tometa" action="#{studyController.toMetadata}" value="#{facesContext.translate('button.metadata')}" ajax="false" rendered="#{studyModel.element.isVariable}" />
    </ui:define>
    <ui:define name="help_de">
			Ändern Sie hier den Namen, die Bezeichnung der Datenbankspalte, den Datentyp, das Label oder die Zuordnung einer Missingliste zum gewählten Bereich bzw. zur gewählten Variablen. Außerdem können Sie weitere Variabenattribute deinieren. Um Ihre Änderungen zu speichern, klicken Sie bitte auf <i>Übernehmen</i>.<br />
      <br />
Die Spalten der Tabelle für weitere Variablenattribute bedeuten:
<table>
        <tr>
          <td>Typ</td>
          <td>Klasse des Attributs, z.B. Label, Intervall, Liste</td>
        </tr>
        <tr>
          <td>Name</td>
          <td>Name für das Attribut</td>
        </tr>
        <tr>
          <td>Inhalt</td>
          <td>Wert des Attributs, sollte zum Typ passen. Spezifische Editoren für die einzelnen Klassen sind in Vorbereitung.</td>
        </tr>
        <tr>
          <td>bevorzugt</td>
          <td>Bei Vorhandensein mehrer Labels der dargstellten Sprache wird in SQ2 dieses verwendet, falls nicht über den Namen klar ist, welches verwendet werden soll.</td>
        </tr>
        <tr>
          <td>Sprachcode</td>
          <td>Sprache des Werts in der Spalte Inhalt. Wenn möglich, werden Attribute der Zielsprache verwendet.</td>
        </tr>
      </table>
      <br />Der Unique-Name ist nicht veränderbar, da er von Square² zur eindeutigen Identifikation automatisch zugewiesen wird.
		</ui:define>
    <ui:define name="help_en">
			Here you can change the name, the label, or the associated missing list of this section or variable. To save changes please click <i>approve</i>.<br />
      <br />
Die Spalten der Tabelle für weitere Variablenattribute bedeuten:
<table>
        <tr>
          <td>type</td>
          <td>Class of the attribute, e.g. label, interval, list</td>
        </tr>
        <tr>
          <td>name</td>
          <td>Name for the attribute</td>
        </tr>
        <tr>
          <td>content</td>
          <td>Value for the attribute, should match its type. Specific editors for each attribute class is in preparation.</td>
        </tr>
        <tr>
          <td>preferred</td>
          <td>If more than one labels exist for the displayed language SQ2 will use the preferred, if the name does not tell.</td>
        </tr>
        <tr>
          <td>language code</td>
          <td>Laguage of the value in the colun contents. If possible, attributes are displayed in the target language.</td>
        </tr>
      </table>
      <br />Changing the unique name isn't possible. It's assigned automatically by Square² to enable an unambiguous identification.
		</ui:define>
  </ui:composition>
</h:body>
</html>